%Run the TV gradient descent for T iterations with parameters eps and lambda
%Author: Jeff Calder, 2016

function u = TV_2D(u,f,eps,lambda,T)
%Perona Malik anisotropic diffusion PDE

    dt = 1/(1+2*lambda/eps)/2;
    for i=1:T
       i;
       GE = u([2:end,end-1],:,:) - u;
       GW = u([2,1:end-1],:,:) - u;
       GS = u(:,[2:end,end-1],:) - u;
       GN = u(:,[2,1:end-1],:) - u;
       
       u = u + 2*dt*(f-u) +  lambda*dt*(GN./sqrt(eps^2 + GN.^2) + GE./sqrt(eps^2 + GE.^2) + GS./sqrt(eps^2 + GS.^2) + GW./sqrt(eps^2 + GW.^2));
    end


end

