function u = image_seg(I,lambda)
   
   eps = 0.5;

   s = size(I);
   if size(I,3)==3
      f = double(rgb2ycbcr(I));
      f = f(:,:,1);
   else
      f = double(I);
   end
   f = f/255;
   [n,m] = size(f);
   u = zeros(n,m);
   [X,Y] = meshgrid(1:m,1:n);
   u = sin(X*20*pi/m).*sin(Y*20*pi/n);

   e = Inf;
   count = 0;
   t_old = Inf;
 
   seg_plot(I,u);
   drawnow
   pause
   
   dt = pi*eps^2/4/lambda;
   while e > 10 || count < 10000
      fin = f(u>0);
      fout = f(u<=0);
      t1 = sum(sum(u>0));
      t2 = sum(sum(u<=0));

      c1 = 0;
      c2 = 0;
      if t1 > 0
         c1 = sum(fin(:))/t1;
      end
      if t2 > 0
         c2 = sum(fout(:))/t2;
      end
      e=abs(t1-t_old)
      t_old = t1;

      GE = u([2:end,end-1],:,:) - u;
      GW = u([2,1:end-1],:,:) - u;
      GS = u(:,[2:end,end-1],:) - u;
      GN = u(:,[2,1:end-1],:) - u;

      delta = eps./(pi*(eps^2 + u.^2));
      div = (GN./sqrt(eps^2 + GN.^2) + GE./sqrt(eps^2 + GE.^2) + GS./sqrt(eps^2 + GS.^2) + GW./sqrt(eps^2 + GW.^2));
      fid = (f-c2).^2 - (f-c1).^2;
       
      H = lambda*div.*delta + delta.*fid;
      %e = max(abs(H(:)))
      u = u + dt*H;

      seg_plot(I,u);
      drawnow
      
      count = count+1;
   end


end

function seg_plot(I,u)

   s = size(I);
   n = s(1);
   m = s(2);
   [X,Y] = meshgrid(0:m-1,0:n-1);
   imshow(I);
   hold on;
   contour(X,Y,u,[0 0],'red','linewidth',3);
   hold off;

end
